#!/usr/bin/python
"""
This file is part of jam-control.

jam-control is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

fedora-audio-control is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with jam-control.  If not, see <http://www.gnu.org/licenses/>.
"""
import os
from subprocess import *

class PulseController():
    def startPulse(self):
        f = open(os.environ["HOME"] + "/.pulse/client.conf", "r+")
        for line in f:
            if line.count("autospawn") > 0:
                split = line.split("=")
                setting = split[1]
                setting = setting.strip()                
                if setting == "no":
                    f.seek(0)
                    f.write("autospawn = yes")
                    break;
                else:
                    return
       
        call("pulseaudio --start", shell=True)          
        
    def stopPulse(self):
        f = open(os.environ["HOME"] + "/.pulse/client.conf", "r+")
        for line in f:
            if line.count("autospawn") > 0:
                split = line.split("=")
                setting = split[1]
                setting = setting.strip()
                if setting == "yes":   
                    f.seek(0)
                    f.write("autospawn = no ")     
                    break;               
                else:                    
                    return
        
        call("pacmd exit > /dev/null", shell=True)
    def suspendPulse(self):
        call("pacmd suspend",shell=True)
    
    def getStatus(self):
       
        try:
            out = check_output("ps -A|grep pulseaudio", shell=True)
        
         
            if out.count("pulseaudio") > 0:
                return True
            else:
                return False
        except CalledProcessError:
            return False
    
    
    def getSources(self):
        
        out = check_output("pacmd list-sources /dev/null", shell=True)
        # find the number of vailable sources
         
        
        num =  out.count("index:")        
        print str(num) + " sources available"
        start = 0
        while out[start:].find("index:" ) != -1:
            index = out[start:].find("index: ")
            
            print out[index:index+50]
            index += 70
            start = index 
        
        
            